# buildforkernels macro hint: when you build a new version or a new release
# that contains bugfixes or other improvements then you must disable the
# "buildforkernels newest" macro for just that build; immediately after
# queuing that build enable the macro again for subsequent builds; that way
# a new akmod package will only get build when a new one is actually needed
%define buildforkernels
# newest

Name:          nvidia-kmod
Epoch:         1
Version:       275.09.07
# Taken over by kmodtool
Release:       2
Summary:       NVIDIA display driver kernel module
Group:         System Environment/Kernel
License:       Redistributable, no modification permitted
URL:           http://www.nvidia.com/
# Source is created from these files:
#ftp://download.nvidia.com/XFree86/Linux-x86/%{version}/NVIDIA-Linux-x86-%{version}-pkg0.run
#ftp://download.nvidia.com/XFree86/Linux-x86_64/%{version}/NVIDIA-Linux-x86_64-%{version}-pkg0.run

# <switch me> when sources are on kwizart's repo
Source0:       http://rpms.kwizart.net/fedora/SOURCES/nvidia-kmod-data-%{version}.tar.bz2
#Source0:       http://www.diffingo.com/downloads/livna/kmod-data/nvidia-kmod-data-%{version}.tar.bz2
# </switch me>

Source11:       nvidia-kmodtool-excludekernel-filterfile

#Patch0:	        nvidia-2.6.39.patch

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# needed for plague to make sure it builds for i586 and i686
ExclusiveArch:  i686 x86_64

# get the needed BuildRequires (in parts depending on what we build for)
BuildRequires:  %{_bindir}/kmodtool
%{!?kernels:BuildRequires: buildsys-build-fuduntu-kerneldevpkgs-%{?buildforkernels:%{buildforkernels}}%{!?buildforkernels:current}-%{_target_cpu} }
# kmodtool does its magic here
%{expand:%(kmodtool --target %{_target_cpu} --repo fuduntu --kmodname %{name} --filterfile %{SOURCE11} --obsolete-name nvidia-newest --obsolete-version "%{version}" %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null) }

%description
The nvidia %{version} display driver kernel module for kernel %{kversion}.

%prep
# error out if there was something wrong with kmodtool
%{?kmodtool_check}
# print kmodtool output for debugging purposes:
kmodtool  --target %{_target_cpu}  --repo fuduntu --kmodname %{name} --filterfile %{SOURCE11} --obsolete-name nvidia-newest --obsolete-version "%{version}" %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null
%setup -q -c -T -a 0

#%patch0 -p0 -b.2.6.39

for kernel_version  in %{?kernel_versions} ; do
%ifarch %{ix86}
    cp -a nvidiapkg-x86 _kmod_build_${kernel_version%%___*}
%else
    cp -a nvidiapkg-x64 _kmod_build_${kernel_version%%___*}
%endif
done


%build
for kernel_version in %{?kernel_versions}; do
    pushd _kmod_build_${kernel_version%%___*}/kernel/
    ln -s -f Makefile.kbuild Makefile
        if [[ "${kernel_version%%___*}" = *xen ]] ; then
            CC="cc -D__XEN_TOOLS__ \
            -I${kernel_version##*___}/include/asm/mach-xen" \
            IGNORE_XEN_PRESENCE=1 \
            make %{?_smp_mflags}  SYSSRC="${kernel_version##*___}" module
        else
            IGNORE_XEN_PRESENCE=1 \
            make %{?_smp_mflags}  SYSSRC="${kernel_version##*___}" module
        fi
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kernel_version in %{?kernel_versions}; do
    install -D -m 0755 _kmod_build_${kernel_version%%___*}/kernel/nvidia.ko $RPM_BUILD_ROOT/%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}/nvidia.ko
done
%{?akmod_install}


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Sun Jul 24 2011 Andrew Wyatt <andrew@fuduntu.org> - 1:275.09.07-2
- Build for kernel 3.0.0

* Mon Jul 11 2011 Andrew Wyatt <andrew@fuduntu.org> - 1:275.09.07-1
- New Driver and build for 2.6.39.3

* Thu May 19 2011 Andrew Wyatt <andrew@fuduntu.org> - 1:260.19.36-1.6
- Build for kernel 2.6.39

* Tue May 17 2011 Andrew Wyatt <andrew@fuduntu.org> - 1:260.19.36-1.5
- Port to Fuduntu

* Thu May 05 2011 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> - 1:260.19.36-1.4
- rebuild for updated kernel

* Sun Apr 24 2011 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> - 1:260.19.36-1.3
- rebuild for updated kernel

* Mon Apr 04 2011 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> - 1:260.19.36-1.2
- rebuild for updated kernel

* Sat Feb 12 2011 Thorsten Leemhuis <fedora [AT] leemhuis [DOT] info> - 1:260.19.36-1.1
- rebuild for updated kernel

* Fri Jan 21 2011 Nicolas Chauvet <kwizart@gmail.com> - 1:260.19.36-1
- Update to 260.19.36

